"use strict";
var math = require('transduce-math'), undef;

module.exports = function(_r){
  // Math Functions
  // --------------------
  _r.mixin({
    max: max,
    min: min
  });

  var iteratee = _r.iteratee,
      resolveSingleValue = _r.resolveSingleValue;

  // Return the maximum element (or element-based computation).
  function max(f) {
    /*jshint validthis:true */
    resolveSingleValue(this);
    return math.max(iteratee(f));
  }

  // Return the minimum element (or element-based computation).
  function min(f) {
    /*jshint validthis:true */
    resolveSingleValue(this);
    return math.min(iteratee(f));
  }
};
